﻿<?php
$act = isset($_REQUEST['act']) ? $_REQUEST['act'] : "";

# 配置
$config = require_once "./config.php";
if(!$config) {
    $config = [];
}

session_start();

if($act == "login") {
    $password = $_REQUEST["password"];

    if(!isset($config["password"])) {
        echo(-2);
        die;
    }
    
    if($config["password"] == $password) {
        $_SESSION['token'] = time();
        echo(1);
        die;
    }
    
    echo(-1);
    die;
}


if(!file_exists("./lock")) {
    echo(-2);
    exit;
} 

$writeActList = [
    "addFileName", "editFileName", "save"
];

$isNeedLogin = true;

if(in_array($act, $writeActList)) {
    # 游客可以写，并且是写的操作
    if((!empty($config["noLoginCanWrite"])) && $config["noLoginCanWrite"]) {
        $isNeedLogin = false;
    }
} else {
    # 游客可能阅读，并且也不是修改就无需登录
    if(!empty($config["noLoginCanRead"]) && $config["noLoginCanRead"]) {
        $isNeedLogin = false;
    }
}

if(empty($_SESSION['token']) && $isNeedLogin) {
    echo(-0); 
    exit;
}

$open_path = "";

function dd($data) {
    echo "<pre>";
    print_r($data);
}

function json($data) {
    die (json_encode($data));
}

/*
Array
(
    [0] => .
    [1] => ..
    [2] => css
    [3] => edit.html
    [4] => file.php
    [5] => index.php
    [6] => js
    [7] => login.php
    [8] => md
)
*/

if($act == "remove") {
   $data = json_decode(file_get_contents("php://input"), true);
   $root = str_replace('\\', '/', __FILE__);

   $array = explode("/", $root);
   array_pop($array);
    
   $root_path = implode("/", $array);
   $recycle_path = $root_path . "/.recycle";
   if(!is_dir($recycle_path)) {
      mkdir($recycle_path);
   }

   

if(file_exists($data['base'].$data['path'])) {
     
$recycle_path_temp = explode("/", $recycle_path.$data['path']);
     
array_pop($recycle_path_temp);
    
$recycle_path_dir = implode("/", $recycle_path_temp);

if(!is_dir($recycle_path_dir)) {
         
 mkdir($recycle_path_dir);
     
}
   
}
 
  
   if(rename($data['base'].$data['path'], ($recycle_path) . $data['path'])) {
      json(["result" => "ok"]);
   }

   json(["error" => "删除失败"]);
}

if($act == "upload") {
     if(isset($_FILES['file']) && $_FILES['file']['error'] === UPLOAD_ERR_OK) {
        $uploadDir = $_REQUEST["path"];
        $uploadFile = $uploadDir  . '/' . basename($_FILES['file']['name']);

        if (move_uploaded_file($_FILES['file']['tmp_name'], $uploadFile)) {
           json(["result" => "ok"]);
        } else {
            json(["error" => "上传失败"]);
        }
    } 
    json(["error" => "非常上传"]);
}

if($act == "config") {
    exit(file_get_contents("config.json"));
}

if($act == "addFileName") {
    $data = json_decode(file_get_contents("php://input"), true);
    $a = $data["path"];
    $n = $data["name"];
    $icon = $data["icon"];

    if(file_exists($a . "/" . $n)) {
        json(["error" => "文件已存在"]);
    }

    if($icon == "dir") {
        if(is_dir($a . '/' . $n)) {
            json(["error" => "文件夹已存在"]); 
        }
        mkdir($a . '/' . $n);
    } else {
        $file = explode('.', $n);
        $icon = strtolower(array_pop($file));

        file_put_contents($a . "/" . $n, "");
    }
   
    json(["result" => "ok", "path" => $a . "/" . $n, 'name' => $n, 'icon' => $icon]); 
}

if($act == "editFileName") {
    $data = json_decode(file_get_contents("php://input"), true);

    $a = $data["path"];
    $p = getLastParentDir($data["path"]);

    $o = $data["old_name"];
    $n = $data["new_name"];
    
    if($o == $n) {
        json(["error" => "无需修改"]); 
    }
    
    if(is_dir($a))
    {
        $icon = "dir";

        if(is_dir($p . "/" . $n)) {
            json(["error" => "文件夹已存在"]); 
        }
    } else {
        $icon = "file";
        $file = explode('.', $n);
        $icon = strtolower(array_pop($file));

        if(file_exists($p . "/" . $n)) {
            json(["error" => "文件已存在"]); 
        }
    } 


    if(rename($a, $p . "/" . $n)) {
        json(["result" => "ok", "path" => $p . "/" . $n, 'name' => $n, 'icon' => $icon]); 
    }

    exit(-1);
}

if($act == "save") {
    $data = json_decode(file_get_contents("php://input"), true);

    $path = $data["path"];
    if(!is_file($path)) {
        exit(-1);
    }
    $content = $data["content"];
    file_put_contents($path, $content);
    json(["result" => "ok", "content" => $content]);
}

if($act == "dir") {
    if(!empty($_REQUEST["base"])) {
        $open_path = $_REQUEST["base"];
        if(!is_dir($open_path)) {
            exit(-1);
        }
        updateHistory($_REQUEST["base"]);
    }
    $leave = getLeave($open_path) - 1;
    $list = showDir($open_path, 0 , $leave * 3);
    sort($list);

    if(!count($list) && !$open_path) {
        exit;
    }
    
    $data = array();
    $name = getLastDirName($open_path);
    $data[0]["name"] = getLastDirName($name);
    $data[0]["child"] = $list;
    $data[0]["desc"] = $name;
    $data[0]["path"] = $open_path;
    $data[0]["icon"] = "dir";
    json($data);
}


if($act == "file") {
    exit(file_get_contents($_REQUEST['path']));
}

if($act == "search") {
    if(!empty($_REQUEST["base"])) {
        $open_path = $_REQUEST["base"];
    }
    $leave = getLeave($open_path) - 1;
    $arr = searchFile($open_path, 0 , $leave * 3);
    $data = [];

    $keyword = "";
    if(isset($_REQUEST['keyword'])) {
        $keyword = $_REQUEST['keyword'];
    }

    foreach($arr as $key => $value) {
        if($keyword) {
            if(strpos(strtolower($value['desc']), strtolower($keyword)) !== false) {
                $data[$value['desc']] = $value;
            }
        } else {
            $data[$value['desc']] = $value;
        }
    }
    
    $data = array_slice($data, 0, 500);
    sort($data);
    json($data);
}

if($act == "part_dir") {
    # getLastParentDir(__DIR__)
    $path = !empty($_REQUEST["path"]) ? $_REQUEST["path"] : "/";
    
    $data = array();
    $data["path"] = $path;
    json($data);
}



if($act == "open_dir") {
    $keyword = !empty($_REQUEST["keyword"]) ? $_REQUEST["keyword"] : "";
    $path = !empty($_REQUEST["path"]) ? $_REQUEST["path"] : "/";

    
    $arr = searchFileDir($path);
    $data = [];

    $keyword = "";
    if(isset($_REQUEST['keyword'])) {
        $keyword = $_REQUEST['keyword'];
    }

    foreach($arr as $key => $value) {
        if($keyword) {
            if(strpos(strtolower($value['desc']), strtolower($keyword)) !== false) {
                $data[$value['desc']] = $value;
            }
        } else {
            $data[$value['desc']] = $value;
        }
    }
    
    sort($data);
    json($data);
}

function getLastParentDir($path) {
    $array = explode("/", $path);
    array_pop($array);
    
    $paths = implode("/", $array);
    return $paths;
}

function getLastDirName($path) {
    $array = explode("/", $path);
    // 排除空值
    $array = array_filter($array);
    if(count($array) > 2) {
        return array_pop($array);
    }

    return $path;
}

function searchFileDir($dir) {
 
    $data = scandir($dir);
    $file = [];

    foreach($data as $key => $value) {
        if($value == "." || $value == "..") {
            continue;
        }

        $icon = explode('.', $value);
        $file[$dir  . '/' . $value]['desc'] =  ($dir != "/" ? ($dir . "/") : $dir) . $value;
        $file[$dir  . '/' . $value]['name'] = $value;
        $file[$dir  . '/' . $value]['path'] = ($dir != "/" ? ($dir . "/") : $dir) . $value;

        if(is_file($dir . '/' . $value)) {
            $file[$dir  . '/' . $value]['icon'] = $icon;
        } else {
            $file[$dir  . '/' . $value]['icon'] = "dir";
        }
       
        
    }

    return $file;
}


function getLeave($dir) {
    $array = explode("/", $dir);
    // 排除空值
    $array = array_filter($array);
    return count($array);
}


function searchFile($dir, $leave = 0, $can = 3) {
    global $open_path;
 
    $data = scandir($dir);
    $file = [];

    foreach($data as $key => $value) {
        if($value == "." || $value == "..") {
            continue;
        }

        if(is_dir($dir . '/' . $value)) {
            if($leave < $can) {
                $data = searchFile($dir  . '/' . $value, $leave + 1, $can);
                $file = array_merge($file, $data);
            }
        } else {
            $icon = explode('.', $value);
            $file[$dir  . '/' . $value]['desc'] = (explode($open_path, ($dir . "/" . $value)))[1];
            $file[$dir  . '/' . $value]['name'] = $value;
            $file[$dir  . '/' . $value]['path'] = $dir . "/" . $value;
            $file[$dir  . '/' . $value]['icon'] = strtolower(array_pop($icon));
        }
    }

    return $file;
}

function showDir($dir, $leave = 0, $can = 3) {
    global $open_path;

    $data = array();
    try {
        $data = @scandir($dir);
        if(!is_array($data)) {
            $data = [];
        }
    } catch(\Exception $e) {
        $data = [];
    }
    $file = [];
    
    foreach($data as $key => $value) {
        if($value == "." || $value == "..") {
            continue;
        }

        if(is_dir($dir . '/' . $value)) {
            $file[$key]['icon'] = "dir";
            if($leave < $can) {
                $file[$key]["child"] = showDir(($dir != "/" ? $dir : "") . '/' . $value, $leave + 1, $can);
                sort($file[$key]["child"]);
            }
        } else {
            $file[$key]['desc'] = (explode($open_path, (($dir != "/" ? $dir : "") . "/" . $value)))[1];
            $icon = explode('.', $value);
            $file[$key]['icon'] = strtolower(array_pop($icon));
        }
        
        $file[$key]['name'] = $value;
        $file[$key]['path'] = ($dir != "/" ? $dir : "") . "/" . $value;
    }

    return $file;
}

function updateHistory($path) {
    if(isset($_REQUEST['open'])) {
        $config = json_decode(file_get_contents("config.json"), true);

        if(empty($config["history"])) {
            $config["history"] = [];
        }

        array_unshift($config["history"],  $path);

        $config["history"] = array_slice(array_unique($config["history"]), 0 ,10);

        file_put_contents("config.json", json_encode($config));
    }
}